## Vanara.PInvoke.Drt  
PInvoke API (methods, structures and constants) imported from Windows Drt.dll for the Distributed Routing Table (DRT) API.

- Includes methods from drt.dll, drtprov.dll, drttransport.dll  
- Current NuGet release: [![Nuget](https://img.shields.io/nuget/v/Vanara.PInvoke.Drt?logo=nuget&style=flat-square)![Nuget](https://img.shields.io/nuget/dt/Vanara.PInvoke.Drt?label=%20&style=flat-square)](https://www.nuget.org/packages/Vanara.PInvoke.Drt)  
### Methods - 100% API coverage (27 of 27 functions)  
Native Method | Native DLL | Header | Managed Method  
--- | --- | --- | ---  
[DrtClose](https://www.google.com/search?num=5&q=DrtClose+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtClose](https://github.com/dahall/Vanara/search?l=C%23&q=DrtClose)  
[DrtContinueSearch](https://www.google.com/search?num=5&q=DrtContinueSearch+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtContinueSearch](https://github.com/dahall/Vanara/search?l=C%23&q=DrtContinueSearch)  
[DrtCreateDerivedKey](https://www.google.com/search?num=5&q=DrtCreateDerivedKey+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtCreateDerivedKey](https://github.com/dahall/Vanara/search?l=C%23&q=DrtCreateDerivedKey)  
[DrtCreateDerivedKeySecurityProvider](https://www.google.com/search?num=5&q=DrtCreateDerivedKeySecurityProvider+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtCreateDerivedKeySecurityProvider](https://github.com/dahall/Vanara/search?l=C%23&q=DrtCreateDerivedKeySecurityProvider)  
[DrtCreateDnsBootstrapResolver](https://www.google.com/search?num=5&q=DrtCreateDnsBootstrapResolver+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtCreateDnsBootstrapResolver](https://github.com/dahall/Vanara/search?l=C%23&q=DrtCreateDnsBootstrapResolver)  
[DrtCreateIpv6UdpTransport](https://www.google.com/search?num=5&q=DrtCreateIpv6UdpTransport+site%3Alearn.microsoft.com) | drttransport.dll | drt.h | [Vanara.PInvoke.Drt.DrtCreateIpv6UdpTransport](https://github.com/dahall/Vanara/search?l=C%23&q=DrtCreateIpv6UdpTransport)  
[DrtCreateNullSecurityProvider](https://www.google.com/search?num=5&q=DrtCreateNullSecurityProvider+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtCreateNullSecurityProvider](https://github.com/dahall/Vanara/search?l=C%23&q=DrtCreateNullSecurityProvider)  
[DrtCreatePnrpBootstrapResolver](https://www.google.com/search?num=5&q=DrtCreatePnrpBootstrapResolver+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtCreatePnrpBootstrapResolver](https://github.com/dahall/Vanara/search?l=C%23&q=DrtCreatePnrpBootstrapResolver)  
[DrtDeleteDerivedKeySecurityProvider](https://www.google.com/search?num=5&q=DrtDeleteDerivedKeySecurityProvider+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtDeleteDerivedKeySecurityProvider](https://github.com/dahall/Vanara/search?l=C%23&q=DrtDeleteDerivedKeySecurityProvider)  
[DrtDeleteDnsBootstrapResolver](https://www.google.com/search?num=5&q=DrtDeleteDnsBootstrapResolver+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtDeleteDnsBootstrapResolver](https://github.com/dahall/Vanara/search?l=C%23&q=DrtDeleteDnsBootstrapResolver)  
[DrtDeleteIpv6UdpTransport](https://www.google.com/search?num=5&q=DrtDeleteIpv6UdpTransport+site%3Alearn.microsoft.com) | drttransport.dll | drt.h | [Vanara.PInvoke.Drt.DrtDeleteIpv6UdpTransport](https://github.com/dahall/Vanara/search?l=C%23&q=DrtDeleteIpv6UdpTransport)  
[DrtDeleteNullSecurityProvider](https://www.google.com/search?num=5&q=DrtDeleteNullSecurityProvider+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtDeleteNullSecurityProvider](https://github.com/dahall/Vanara/search?l=C%23&q=DrtDeleteNullSecurityProvider)  
[DrtDeletePnrpBootstrapResolver](https://www.google.com/search?num=5&q=DrtDeletePnrpBootstrapResolver+site%3Alearn.microsoft.com) | drtprov.dll | drt.h | [Vanara.PInvoke.Drt.DrtDeletePnrpBootstrapResolver](https://github.com/dahall/Vanara/search?l=C%23&q=DrtDeletePnrpBootstrapResolver)  
[DrtEndSearch](https://www.google.com/search?num=5&q=DrtEndSearch+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtEndSearch](https://github.com/dahall/Vanara/search?l=C%23&q=DrtEndSearch)  
[DrtGetEventData](https://www.google.com/search?num=5&q=DrtGetEventData+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetEventData](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetEventData)  
[DrtGetEventDataSize](https://www.google.com/search?num=5&q=DrtGetEventDataSize+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetEventDataSize](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetEventDataSize)  
[DrtGetInstanceName](https://www.google.com/search?num=5&q=DrtGetInstanceName+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetInstanceName](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetInstanceName)  
[DrtGetInstanceNameSize](https://www.google.com/search?num=5&q=DrtGetInstanceNameSize+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetInstanceNameSize](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetInstanceNameSize)  
[DrtGetSearchPath](https://www.google.com/search?num=5&q=DrtGetSearchPath+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetSearchPath](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetSearchPath)  
[DrtGetSearchPathSize](https://www.google.com/search?num=5&q=DrtGetSearchPathSize+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetSearchPathSize](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetSearchPathSize)  
[DrtGetSearchResult](https://www.google.com/search?num=5&q=DrtGetSearchResult+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetSearchResult](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetSearchResult)  
[DrtGetSearchResultSize](https://www.google.com/search?num=5&q=DrtGetSearchResultSize+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtGetSearchResultSize](https://github.com/dahall/Vanara/search?l=C%23&q=DrtGetSearchResultSize)  
[DrtOpen](https://www.google.com/search?num=5&q=DrtOpen+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtOpen](https://github.com/dahall/Vanara/search?l=C%23&q=DrtOpen)  
[DrtRegisterKey](https://www.google.com/search?num=5&q=DrtRegisterKey+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtRegisterKey](https://github.com/dahall/Vanara/search?l=C%23&q=DrtRegisterKey)  
[DrtStartSearch](https://www.google.com/search?num=5&q=DrtStartSearch+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtStartSearch](https://github.com/dahall/Vanara/search?l=C%23&q=DrtStartSearch)  
[DrtUnregisterKey](https://www.google.com/search?num=5&q=DrtUnregisterKey+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtUnregisterKey](https://github.com/dahall/Vanara/search?l=C%23&q=DrtUnregisterKey)  
[DrtUpdateKey](https://www.google.com/search?num=5&q=DrtUpdateKey+site%3Alearn.microsoft.com) | drt.dll | drt.h | [Vanara.PInvoke.Drt.DrtUpdateKey](https://github.com/dahall/Vanara/search?l=C%23&q=DrtUpdateKey)  
### Enumerations  
Native Enum | Header | Managed Enum  
--- | --- | ---  
[DRT_ADDRESS_FLAGS](https://www.google.com/search?num=5&q=DRT_ADDRESS_FLAGS+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_ADDRESS_FLAGS](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_ADDRESS_FLAGS)  
[DRT_EVENT_TYPE](https://www.google.com/search?num=5&q=DRT_EVENT_TYPE+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_EVENT_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_EVENT_TYPE)  
[DRT_LEAFSET_KEY_CHANGE_TYPE](https://www.google.com/search?num=5&q=DRT_LEAFSET_KEY_CHANGE_TYPE+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_LEAFSET_KEY_CHANGE_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_LEAFSET_KEY_CHANGE_TYPE)  
[DRT_MATCH_TYPE](https://www.google.com/search?num=5&q=DRT_MATCH_TYPE+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_MATCH_TYPE](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_MATCH_TYPE)  
[DRT_REGISTRATION_STATE](https://www.google.com/search?num=5&q=DRT_REGISTRATION_STATE+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_REGISTRATION_STATE](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_REGISTRATION_STATE)  
[DRT_SCOPE](https://www.google.com/search?num=5&q=DRT_SCOPE+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_SCOPE](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_SCOPE)  
[DRT_SECURITY_MODE](https://www.google.com/search?num=5&q=DRT_SECURITY_MODE+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_SECURITY_MODE](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_SECURITY_MODE)  
[DRT_STATUS](https://www.google.com/search?num=5&q=DRT_STATUS+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_STATUS](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_STATUS)  
### Structures  
Native Structure | Header | Managed Structure  
--- | --- | ---  
[BOOTSTRAPADDRESSES](https://www.google.com/search?num=5&q=BOOTSTRAPADDRESSES+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.DRT_EVENT_DATA.UNION.STATUSCHANGE.BOOTSTRAPADDRESSES](https://github.com/dahall/Vanara/search?l=C%23&q=BOOTSTRAPADDRESSES)  
[DRT_ADDRESS](https://www.google.com/search?num=5&q=DRT_ADDRESS+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_ADDRESS](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_ADDRESS)  
[DRT_ADDRESS_LIST](https://www.google.com/search?num=5&q=DRT_ADDRESS_LIST+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_ADDRESS_LIST](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_ADDRESS_LIST)  
[DRT_BOOTSTRAP_PROVIDER](https://www.google.com/search?num=5&q=DRT_BOOTSTRAP_PROVIDER+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_BOOTSTRAP_PROVIDER](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_BOOTSTRAP_PROVIDER)  
[DRT_BOOTSTRAP_RESOLVE_CONTEXT](https://www.google.com/search?num=5&q=DRT_BOOTSTRAP_RESOLVE_CONTEXT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.DRT_BOOTSTRAP_RESOLVE_CONTEXT](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_BOOTSTRAP_RESOLVE_CONTEXT)  
[DRT_DATA](https://www.google.com/search?num=5&q=DRT_DATA+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_DATA](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_DATA)  
[DRT_EVENT_DATA](https://www.google.com/search?num=5&q=DRT_EVENT_DATA+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_EVENT_DATA](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_EVENT_DATA)  
[DRT_REGISTRATION](https://www.google.com/search?num=5&q=DRT_REGISTRATION+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_REGISTRATION](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_REGISTRATION)  
[DRT_SEARCH_INFO](https://www.google.com/search?num=5&q=DRT_SEARCH_INFO+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_SEARCH_INFO](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_SEARCH_INFO)  
[DRT_SEARCH_RESULT](https://www.google.com/search?num=5&q=DRT_SEARCH_RESULT+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_SEARCH_RESULT](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_SEARCH_RESULT)  
[DRT_SECURITY_PROVIDER](https://www.google.com/search?num=5&q=DRT_SECURITY_PROVIDER+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_SECURITY_PROVIDER](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_SECURITY_PROVIDER)  
[DRT_SETTINGS](https://www.google.com/search?num=5&q=DRT_SETTINGS+site%3Alearn.microsoft.com) | drt.h | [Vanara.PInvoke.Drt.DRT_SETTINGS](https://github.com/dahall/Vanara/search?l=C%23&q=DRT_SETTINGS)  
[HDRT](https://www.google.com/search?num=5&q=HDRT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.HDRT](https://github.com/dahall/Vanara/search?l=C%23&q=HDRT)  
[HDRT_REGISTRATION_CONTEXT](https://www.google.com/search?num=5&q=HDRT_REGISTRATION_CONTEXT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.HDRT_REGISTRATION_CONTEXT](https://github.com/dahall/Vanara/search?l=C%23&q=HDRT_REGISTRATION_CONTEXT)  
[HDRT_SEARCH_CONTEXT](https://www.google.com/search?num=5&q=HDRT_SEARCH_CONTEXT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.HDRT_SEARCH_CONTEXT](https://github.com/dahall/Vanara/search?l=C%23&q=HDRT_SEARCH_CONTEXT)  
[HDRT_TRANSPORT](https://www.google.com/search?num=5&q=HDRT_TRANSPORT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.HDRT_TRANSPORT](https://github.com/dahall/Vanara/search?l=C%23&q=HDRT_TRANSPORT)  
[LEAFSETKEYCHANGE](https://www.google.com/search?num=5&q=LEAFSETKEYCHANGE+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.DRT_EVENT_DATA.UNION.LEAFSETKEYCHANGE](https://github.com/dahall/Vanara/search?l=C%23&q=LEAFSETKEYCHANGE)  
[REGISTRATIONSTATECHANGE](https://www.google.com/search?num=5&q=REGISTRATIONSTATECHANGE+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.DRT_EVENT_DATA.UNION.REGISTRATIONSTATECHANGE](https://github.com/dahall/Vanara/search?l=C%23&q=REGISTRATIONSTATECHANGE)  
[STATUSCHANGE](https://www.google.com/search?num=5&q=STATUSCHANGE+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.DRT_EVENT_DATA.UNION.STATUSCHANGE](https://github.com/dahall/Vanara/search?l=C%23&q=STATUSCHANGE)  
[UNION](https://www.google.com/search?num=5&q=UNION+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.DRT_EVENT_DATA.UNION](https://github.com/dahall/Vanara/search?l=C%23&q=UNION)  
### Classes  
Native Class | Header | Managed Class  
--- | --- | ---  
[SafeHDRT](https://www.google.com/search?num=5&q=SafeHDRT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.SafeHDRT](https://github.com/dahall/Vanara/search?l=C%23&q=SafeHDRT)  
[SafeHDRT_TRANSPORT](https://www.google.com/search?num=5&q=SafeHDRT_TRANSPORT+site%3Alearn.microsoft.com) |  | [Vanara.PInvoke.Drt.SafeHDRT_TRANSPORT](https://github.com/dahall/Vanara/search?l=C%23&q=SafeHDRT_TRANSPORT)  
